#include "binary.h"

Binary::Binary(int size)
{
    this->size = size;
    digit = new uchar[size];
    for(int i=0;i<size;++i)
    {
        digit[i] = 0;
    }
}

void Binary::readChar(int src)
{
    QList<uchar> rest;

    int quo =  src/2;
    rest.append(src%2);
    while(quo != 0)
    {
        rest.append(quo%2);
        quo = quo/2;
    }
    for(int i=0;i<size;++i)
    {
        if(i<rest.size())
            digit[i] = rest.at(i);
        else
            return;
    }
}

int Binary::toInteger()
{
    int result = 0;
    for(int i=0;i<size;++i)
    {
        result += digit[i]*(pow(2,i));
    }
    return result;
}

void Binary::setBit(uchar bit, int number)
{
    if(number<size)
        digit[number] = bit;
}

uchar Binary::getBit(int number)
{
    if(number<size)
        return digit[number];
}
