#include "mainwindow.h"
#include "ui_mainwindow.h"
#define RANGE_WIDTH 1///0.004482
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    useLast = false;
    hp = 0;
    ui->setupUi(this);
    this->setFixedSize(1200,650);
    line1 = ui->lineEdit;
    line2 = ui->lineEdit_2;
    line3 = ui->lineEdit_3;
    port = new QextSerialPort("\\\\.\\com18", QextSerialPort::EventDriven);
    port->setPortName("\\\\.\\com18");
    port->setQueryMode(QextSerialPort::EventDriven);
    connect(port, SIGNAL(readyRead()), this, SLOT(onDataAvailable()));
    connect(this, SIGNAL(output(QList<int>)), this, SLOT(onOutput(QList<int>)));
    connect(this, SIGNAL(out(int)), this, SLOT(textOut(int)));
    port->open(QIODevice::ReadWrite | QIODevice::Unbuffered);
    port->setBaudRate(BAUD9600);
    port->setFlowControl(FLOW_OFF);
    port->setParity(PAR_NONE);
    port->setDataBits(DATA_8);
    port->setStopBits(STOP_1);
    if(port->isOpen())
        line1->setText("succees");
    else
        line1->setText("shit happend");
}

void MainWindow::onDataAvailable()
{
    QByteArray result = port->readAll();

            QList<int> data;

            for(int i = 0; i < result.size(); ++i)
            {
                const uchar val = result.at(i);
                data.append(val);
            }
            onData(data);
}

void MainWindow::sendChar(const char data)
{
    QMutex m;
    m.lock();
    port->flush();
    int i = port->write((const char*) &data, 1);
    m.unlock();
}

void MainWindow::onData(QList<int> src)
{
    QList<int> data;
    int k;
    if(useLast)
    {
        k=1;
        Binary bin10(10);
        bin10.readChar(src.at(0));
        last->setBit(bin10.getBit(1),9);
        last->setBit(bin10.getBit(0),8);
        data.append(last->toInteger());
    }
    else
        k=0;
    for(int i=0;i<(src.size()-k)/2;++i)
    {
        Binary bin(10);
        bin.readChar(src.at(i*2+k));
        Binary bin10(10);
        bin10.readChar(src.at(i*2+1+k));
        bin.setBit(bin10.getBit(1),9);
        bin.setBit(bin10.getBit(0),8);
        data.append(bin.toInteger());
    }
    if((src.size()-k)%2 != 0)
    {
        useLast = true;
        last = new Binary(10);
        last->readChar(src.at(src.size()-1));
    }
    else
        useLast = false;
    emit output(data);
}

void MainWindow::onOutput(QList<int> src)
{
    for(int i=0;i<src.size();++i){
        h[hp].append(src.at(i));
        qDebug() << "h :" << hp << "v: " << h[hp].at(i);
        ++hp;
        if(hp>=3)
            hp=0;
    }
    if(h[0].size()>50)
    {
        qreal result = 0;
        for(int i=0;i<h[0].size();++i)
        {
            result = result + h[0].at(i);
        }
        result = (result / h[0].size())*RANGE_WIDTH;
        QString num;
        num.setNum(result);
        str1.append(num);
        h[0].clear();
        out(0);
    }

    if(h[1].size()>50)
    {
        int result = 0;
        for(int i=0;i<h[1].size();++i)
        {
            result = result + h[1].at(i);
        }
        result = (result / h[1].size())*RANGE_WIDTH;
        QString num;
        num.setNum(result);
        str2.append(num);
        h[1].clear();
        out(1);
    }
    if(h[2].size()>50)
    {
        int result = 0;
        for(int i=0;i<h[2].size();++i)
        {
            result = result + h[2].at(i);
        }
        result = (result / h[2].size())*RANGE_WIDTH;
        QString num;
        num.setNum(result);
        str3.append(num);
        h[2].clear();
        out(2);
    }
}

void MainWindow::textOut(int n){
    if(n==0)
    {
        line1->setText(str1);
        str1.clear();
    }
    if(n==1)
    {
        line2->setText(str2);
        str2.clear();
    }
    if(n==2)
    {
        line3->setText(str3);
        str3.clear();
    }
}

MainWindow::~MainWindow()
{
    delete ui;
}
