#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "qextserialport.h"
#include <QMutex>
#include <QLineEdit>
#include <QTextBrowser>
#include <QGridLayout>
#include "binary.h"
#include <QDebug>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void sendChar(const char data);
signals:
    void output(QList<int> str);
    void out(int);
public slots:
    void onDataAvailable( );
    void onOutput(QList<int> src);
    void onData(QList<int> src);
    void textOut(int);
private:
    int hp;
    QLineEdit *line1;
    QLineEdit *line2;
    QLineEdit *line3;
    Ui::MainWindow *ui;
    QextSerialPort *port;
    bool useLast;
    QString str1;
    QString str2;
    QString str3;
    Binary *last;
    int test;
    QList<int> h[3];
};

#endif // MAINWINDOW_H
